关闭

为arm平台构建linux内核树

145人阅读 评论(0) 收藏 举报
分类:


前面说到要编写Linux 2.6的驱动,必须建立内核源码树,前面建立的源码树是针对i686平台的,但是我么嵌入式系统用的是arm平台,所以也要建立arm平台的内核源码树。

首先下载与你嵌入式系统平台版本号一致的linux内核,我的版本为2.6.30.

第一步:先解压源代码

tar -jxvf linux-2.6.30.tar.bz2

第二步:进入刚才解压后的目录linux-2.6.30

cd linux-2.6.30

然后执行make mrproper命令,该命令确保源代码目录下没有不正确的.o文件以及文件的互相依赖。

因为我是为arm平台编译内核,需要用到交叉编译工具(可从ftp://ftp.arm.linux.org.uk/pub/armlinux/toolchain站点下载)。配置内核之前还要修改内核最上层目录下的Makefile(linux-2.6.30/Makefile)

把文件中的

ARCH ?= $(SUBARCH)改为:

ARCH =arm

CROSS_COMPILE ?=

改为

CROSS_COMPILE   =arm-linux-

接着就是配置内核,可以使用下面命令中的一个:

make config(基于文本的最为传统的配置界面,不推荐使用)

make menuconfig(基于文本菜单的配置界面)

make xconfig(要求QT被安装)

make gconfig(要求GTK+被安装)

配置内容可参考相关文献。

第三步:配置过内核之后,就可以进行编译了。执行以下命令中的一种:

make (生成一个压缩的内核影像)

make bzImage(生成一个使用gzip压缩的内核)

第四步:

执行make modules(编译在内核配置时选中的模块)在此过程中可能会遇到某些模块不能编译通过,把相应模块去除再执行

make modules_install安装内核

安装的内核在/lib/modules/2.6.30里。

至此,针对arm平台的内核树安装完成。

内核最上层的makefile在内核编译过程中起了决定性的作用,在编译过程中遇到的许多问题都可以在里面得到解决的思路,希望大家多看看。

在嵌入式系统加载模块时可能会遇到如下错误:

EmbedSky_hello: version magic '2.6.30.4 mod_unload ARMv4 ' should be '2.6.30.4-EmbedSky mod_unload ARMv4 '

insmod: cannot insert 'EmbedSky_hello.ko': invalid module format

出错原因:模块版本与内核版本不匹配!

解决办法:导入预设配置信息,进入menuconfig 继续配置General config ->......Local version -> 加入如下内容:“-EmbedSky ”退出保存为 .config ,重新编译内核,将EmbedSky_hello.ko复制到板子,然后再“#insmod EmbedSky_hello.ko,然后就congratulations,you succeed啦!

编译的内核树最好是生成开发板镜像的内核,不然也会编译出错,在编译开发板内核的时候可能会出现

In function 'cx88_audio_initdev':

drivers/media/video/cx88/cx88-alsa.c:806: error: implicit declaration of function 'snd_card_create'

出现这些错误的原因是内核配置时多选了几项重复的模块,只要在Device driver-->Multimedia devices-->

video capture adapters中,或再V4L USB devices中去除cx88等模块

或者直接用EmbedSky的配置文件

0
0

查看评论
* 以上用户言论只代表其个人观点,不代表CSDN网站的观点或立场
    个人资料
    • 访问:72981次
    • 积分:1260
    • 等级:
    • 排名:千里之外
    • 原创:43篇
    • 转载:82篇
    • 译文:0篇
    • 评论:0条